#include "font.h"



uint8_t everRead=0;//¼FlashǷʼ	0ûгʼ1ʼ

sFONT Font8x16 = {
  10*1024, /*Flashʼַ*/
  8, /* Width */
  16, /* Height */
#if !FLASH_FONT	//ʹڴеֿʱڴַ
  ASCII8x16_Table,	/* ڴַ */
#endif
};

sFONT Font16x24 = {
  12*1024, /*ʼַ*/
  16, /* Width */
  24, /* Height */
#if !FLASH_FONT	//ʹڴеֿʱڴַ
  ASCII16x24_Table,	/* ڴַ */
#endif
};

sFONT Font24x32 = {
  17*1024, /*ʼַ*/
  24, /* Width */
  32, /* Height */
#if !FLASH_FONT	//ʹڴеֿʱڴַ
  ASCII24x32_Table,	/* ڴַ */
#endif
};
sFONT GB2312_H1616 = {
  256*1024, /*ʼַ*/
  WIDTH_CH_CHAR, /* Width */
  HEIGHT_CH_CHAR, /* Height */
  /* ûڴַڴռ̫ */
};


//ѡʹFLASHģSDģ
#if GBKCODE_FLASH


// 0HZLIBģ(ɰ棬ʹ), 1GB2312ģ
#if 1

/**
  * @brief  ȡFLASHʾֿ
  * @param  pBuffer:洢ֿĻ
  * @param  c  Ҫȡ
  * @retval None.
  */
uint8_t GetGBKCode_from_EXFlash( uint8_t * pBuffer, uint16_t c)
{
#if FLASH_FONT	//ʹڴеֿʱ֧
	unsigned char High8bit,Low8bit;
	unsigned int pos,datnum;
	
	High8bit= c >> 8;     /* ȡ8λ */
	Low8bit= c & 0x00FF;  /* ȡ8λ */
	
	//Ҫȡֽ
	datnum=GB2312_H1616.Width*GB2312_H1616.Height/8;
	/*GB2312 ʽ*/	
	pos = ( (High8bit-0xa1)*94 + Low8bit-0xa1 )*datnum;
	//ȡֿ  
	SPI_FLASH_BufferRead(pBuffer , GB2312_H1616.AddrStart + pos , datnum);
#else
	FONT_Bebug("ǰ岻֧\n");
#endif
	return 0;  
}

/**
  * @brief  ȡFlashеӢַ
  * @param  pBuffer:洢ֿĻ
  * @param  c  Ҫȡ
  * @param  Fonts 
  * @retval None.
  */
uint8_t GetConslonsCode_from_EXFlash( uint8_t * pBuffer, const char c , sFONT *Fonts)
{
	unsigned char chr;
	unsigned int pos,datnum;
	
	chr = c - ' ';
	
	//Ҫȡֽ(ռdatnumֽ)
	datnum = (Fonts->Width * Fonts->Height)/8;
	/*ģƫƵַ*/
	pos = chr*datnum;
	#if FLASH_FONT
	//ȡֿ  
	SPI_FLASH_BufferRead(pBuffer , Fonts->AddrStart + pos , datnum);
	#else
	for(uint16_t i=0;i<datnum;i++)
	{
		*(pBuffer+i) = (Fonts->Font_Table[pos+i]);//ȡĳַ׵ַ
	}
	#endif
	return 0;  
}


#else	//ɰģHZLIB ׵ĺ

	/*HZLIBֿ洢FLASHʼַ*/
	#define HZLIB_START_ADDRESS   1*4096

	//ɰHZLIBֿʹõĺHZLIBֱ֧
	//ʹõѰַʽGB2312Ҳ
	int GetGBKCode_from_EXFlash( uint8_t * pBuffer, uint16_t c)
	{ 
		unsigned char High8bit,Low8bit;
		unsigned int pos;
		static uint8_t everRead=0;
		
		High8bit= c >> 8;     /* ȡ8λ */
		Low8bit= c & 0x00FF;  /* ȡ8λ */	
		
		//ģʹõѰַʽGB2312
		pos = ((High8bit-0xa0-16)*94+Low8bit-0xa1)*WIDTH_CH_CHAR*HEIGHT_CH_CHAR/8;
		//ַָHZLIBģĵַHZLIB_START_ADDRESS
		SPI_FLASH_BufferRead(pBuffer,HZLIB_START_ADDRESS+pos,WIDTH_CH_CHAR*HEIGHT_CH_CHAR/8);
		//printf ( "%02x %02x %02x %02x\n", pBuffer[0],pBuffer[1],pBuffer[2],pBuffer[3]);
		
		return 0;
	}
	#endif

#else //SDģ

	static FIL fnew;	/* file objects */
	static FATFS fs;	/* Work area (file system object) for logical drives */
	static FRESULT res_sd; 
	static UINT br;		/* File R/W count */

	/**
	  * @brief  ȡSDʾֿ
		* @param  pBuffer:洢ֿĻ
		* @param  c  Ҫȡ
	  * @retval None.
	  */
	int GetGBKCode_from_sd ( uint8_t * pBuffer, uint16_t c)
	{ 
		unsigned char High8bit,Low8bit;
		unsigned int pos;
		static uint8_t everRead = 0;
		
		High8bit= c >> 8;     /* ȡ8λ */
		Low8bit= c & 0x00FF;  /* ȡ8λ */
			
		pos = ((High8bit-0xa1)*94+Low8bit-0xa1)*WIDTH_CH_CHAR*HEIGHT_CH_CHAR/8;
		
		/*һʹãļϵͳʼsd*/
		if(everRead == 0)
		{
			res_sd = f_mount(&fs,"0:",1);
			everRead = 1;
		}
		res_sd = f_open(&fnew , GBKCODE_FILE_NAME, FA_OPEN_EXISTING | FA_READ);
		if ( res_sd == FR_OK ) 
		{
			f_lseek (&fnew, pos);		//ָƫ
			f_read( &fnew, pBuffer, WIDTH_CH_CHAR*HEIGHT_CH_CHAR/8, &br );//16*16Сĺ ģ ռ16*16/8ֽ
			f_close(&fnew);
			return 0;  
		}
		else
			return -1;    
	}

#endif






